//==== M05xx ģ˵ =============================================================== 
// 22MHzPLLƵ 49.7664MHz. ⻹Timer3, UART0, ADC, PWM, GPIO
// Copyright reserved by Nuvoton (SH) Ltd.  All right reserved.
// Author : Angus Wang. Date : 2013/12/27 
//=======================================================================================
#include "M05xxDx.h"

void UnlockReg(void)
{
  while((GCR->REGWRPROT & 1) == 0){                        // ֹϽɹ
    GCR->REGWRPROT = 0x59 ; 
    GCR->REGWRPROT = 0x16 ; 
    GCR->REGWRPROT = 0x88 ;
  }
} 
void SysClk_Init(void)                    // PLL:  (22.1184M/2)*9 = 2 * 49.7664MHz 
{
  UnlockReg() ;                                            // 
  CLK->PWRCON |= PWR_22M_ON_ ;                             // õ 
  while((CLK->CLKSTATUS & CLKSTA_22M_STABLE) == 0) ;       // ȶ
  CLK->PLLCON = PLL_CLK_SRC_22M | PLL_IN_DIV(2) | PLL_MUL(9) ;
  while((CLK->CLKSTATUS & CLKSTA_PLL_STABLE) == 0) ;       //  PLL ȶ
  
  CLK->CLKDIV  = HCLK_DIV_4bit(2)                          // ȷƵ,֤л󲻳50MHz
               | ADC_CLK_DIV_8bit(3) ;            
  CLK->CLKSEL0 = CLKS0_HCLK_PLL_ ;                         // ٰ HCLK  PLL ʱ
  CLK->CLKSEL1 = CLKS1_PWM23_HCLK 
               | CLKS1_PWM01_HCLK                          // õ, ѡʱ
               | CLKS1_TMR3_HCLK  
               | CLKS1_UART_PLL 
               | CLKS1_ADC_HCLK ;
  CLK->CLKSEL2 = CLKS2_PWM67_HCLK 
               | CLKS2_PWM45_HCLK ;
  
  CLK->APBCLK  = CLK_PWM67_EN                              // ʹʱ
               | CLK_PWM45_EN                              // дĴŻЧ
               | CLK_PWM23_EN 
               | CLK_PWM01_EN
               | CLK_TMR3_EN  
               | CLK_UART0_EN 
               | CLK_ADC_EN ;
                                                           // صõʱ
  CLK->PWRCON = PWR_22M_ON_                                // ֻõʱ,ʡ
              | PWR_DOWN_WAIT_WFI_                         
              | PWR_WAKEUP_DELAY_   ;                       

  LOCKREG() ;                                              // 
}
//// Timer1, 1MHz , ͨöʱ, 16.77 ///////////////////////////////////
// дTimer Ĵ2TimerʱӺЧ, Timerʱܵ,дҪʱ,ܶ    
void Timer3Init(void)   
{                                                         
  TIMER3->TCSR  = T_DEBUG_WORK | T_IE | T_MODE_CONTINUOUS  // 2 25MHz ʱӺٶ
                | T_CRST | T_TDR_EN + 49 ;                 // λ, 50Ƶ, 1us 
  TIMER3->TCMPR = 0 ;                                 
  NVIC_SetPriority(TMR3_IRQn, 2) ;                         // жȼΪ 2
  NVIC->ISER[0] = 1<<TMR3_IRQn ;		                       // ж
  TIMER3->TCSR |= T_CEN ;                                  // Timer, Ƕдָ
}
void Delayus(uint32_t Tim)                                 // 0xFFFFFF, Լ16.77 
{
  uint32_t Tick = TIMER3->TDR ;
  while(((TIMER3->TDR - Tick)&0xFFFFFF) <= Tim) ;
}
void UART0_Init(uint32_t Baud)
{
  UART0->FUNSEL = SIO_MODE_UART_0 ;                       // UART ģʽ
  UART0->LCR    = WORD_LEN_8BIT ;                         // 8λ, 1-stop, no parity
  UART0->BAUD   = (DIV_X_EN | DIV_X_ONE)+99532800/Baud-2; // UART ʱѡ PLL
  UART0->FCR    = RTS_14BYTE_TRG | RX_FIFO_8BYTE_INT ;    // 14byteRTSЧ,8ֽж
  UART0->TOR    = 250 ;                                   // 250λʱղ, ʱж
  UART0->IER    = 0 ;                                     // ж, ûʹ
  NVIC_SetPriority(UART0_IRQn, 2) ;                   
  NVIC->ISER[0] = 1 << UART0_IRQn ;                       // ж
}
//// ѷFiFo /////////////////////////////////////////////////////////////////////
// β :  *pStr, ַָ
//          Cnt , ַ
//  :   pStr, ʣַַ, ַ, 򷵻 0
uint8_t* Tx0FillFiFo(uint8_t*pStr, uint32_t Cnt)
{
  if(Cnt){                                                 // ַҪ
    do{
      if( UART0->FSR & TX_FIFO_FULL ) break ;              // FiFo˾˳ѭ        
      UART0->THR = *pStr++ ;                               //  FiFo ַ
    }while(--Cnt) ;                                        // ֱַ
  }
  if(Cnt) return  pStr ; 
  else    return  0    ;                               
}
void PWM_Init(void)
{   
  PWMA->PPR  = PPR_PWM01_DIV(250) ;                        // PWM ʱ250Ƶ, 200KHz
  PWMA->CSR  = CSR_DIV4_CH(0) ;                            // ͨ04Ƶ,  50KHz
  PWMA->PCR  = PCR_EN_CH(0) | PCR_PERIOD_MOD_CH(0) ;       // ʹPWM0, ģʽ
  PWMA->POE  = POE_CH(0) ;                                 // PWM ʹ 
  PWMA->PIER = 0 ;                                         // ж
  PWMA->CNR0 = 50000 ;                                     // ֵ, Լ 1  
  PWMA->CMR0 = 40000 ;                                     // ߵƽ  0.8   
}
void ADC_Init(void)
{
  ADC->CR = AD_EN | AD_SINGLE_MODE_0 ;                     // ADC ʹܵģʽ  
}
//// еGPIO, յGPIO׼˫, 1 ////////////////////////////////
void GPIO_Init(void)
{
  P0->DOUT    = 0xFF ;                                     // дֵ
  P0->PMD     = Px7_QB | Px6_QB | Px5_QB | Px4_QB          // GPIOһлȷֵ  
              | Px3_QB | Px2_QB | Px1_QB | Px0_QB ;
  GCR->P0_MFP = 0 ;                                        // л GPIO ڹ
                                                      
  P1->DOUT    = 0xFF ;     
  P1->PMD     = Px7_QB | Px6_QB | Px5_QB | Px4_QB | Px3_QB | Px2_QB | Px1_QB | Px0_QB ;
  GCR->P1_MFP = 0 ;                                   

  P2->DOUT    = 0xF5 ;     
  P2->PMD     = Px7_QB | Px6_QB | Px5_QB | Px4_QB          // λLED,   
              | Px3_OUT | Px2_OUT | Px1_OUT | Px0_OUT ;    // P20 PWMӹ,ʲô
  GCR->P2_MFP = P20_PWM0 ;                                 // P20  PWM0 
                                                           // 0, GPIO
  P3->DOUT    = 0xFF ;     
  P3->PMD     = Px7_QB | Px6_OUT | Px5_QB | Px4_QB         // Nutiny  P36  LED
              | Px3_QB | Px2_QB | Px1_QB | Px0_QB ;                               
  GCR->P3_MFP = P31_TXD0 ;                                 // UART0 ͽ,

  P4->DOUT    = 0xFF ;     
  P4->PMD     = Px7_QB | Px6_QB | Px5_QB | Px4_QB | Px3_QB | Px2_QB | Px1_QB | Px0_QB ;
  GCR->P4_MFP = 0 ;                                     
}
//=======================================================================================
// ---------------------------main()----------------------------------------------
//=======================================================================================
int main(void)
{
  uint16_t temp16 ;
  uint32_t LED_Flash = 1 ;
  
  // һ, ʱѡ,ʱʹܺ,дĴЧ ///////////////////////////
  SysClk_Init() ;
  
  // ڶ, Ƭڸ蹦 /////////////////////////////////////////////////////////
  Timer3Init() ;                                           //Timer1,ʹDelayus()
  PWM_Init() ;
  ADC_Init() ;

  // , GPIOڹ, GPIOڿʼȷֵ /////////////////////////////////////
  GPIO_Init() ;                                            // PWM0 ϵ LED ʼ˸
  UART0_Init(115200) ;
  Tx0FillFiFo("\nUART0 is OK !   ", 16) ;                  // ú, ָʾһ  
  
  // ѭ /////////////////////////////////////////////////////////////////////////////
  while(1){    
    Delayus(50000) ;                                       // ʱ 50  
    LED_Flash <<= 1 ;                                      // P36_LED
    if(LED_Flash & 0x40000000) LED_Flash |= 1 ;      
    P36 = ~LED_Flash ;                                     // ӰP3
    
    ADC->CHER = 1 ;                                        // ADC ѡͨ0
    ADC->CR  |= AD_START_BUSY ;                            //  ADC ת
    while(ADC->CR & AD_START_BUSY) ;                       // ȴת
    temp16 = ADC->DR[0] ;                                  //  ADC ת
    
    P2->DOUT |= 0xF ;                                      // λ 1 
    if(temp16 > 3000) P23 = 0 ;                            // LED ļʾ ADC ֵ
    if(temp16 > 2000) P22 = 0 ;                            // ͵ƽ LED 
    if(temp16 > 1000) P21 = 0 ;  
  }
}
void TMR3_IRQHandler(void)                                 // Լ 16.77 жһ
{
  TIMER3->TISR   = ~0 ;                                    // жϱ־
  TIMER3->TEXISR = ~0 ;                                    // ־2Timerʱ(25M)
}
